package com.its.op.service.its.vds;

import com.its.op.dao.repository.its.vds.TbVdsCtlrRepository;
import com.its.op.dao.repository.its.vds.TbVdsCtlrSttsHsRepository;
import com.its.op.dao.repository.its.vds.TbVdsDtctClctPnstRepository;
import com.its.op.dto.its.common.*;
import com.its.op.dto.its.vds.TbVdsCtlrDto;
import com.its.op.dto.its.vds.TbVdsCtlrSttsDto;
import com.its.op.entity.its.vds.TbVdsCtlr;
import com.its.op.global.CodeManager;
import com.its.utils.ItsUtils;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVdsCtlrService {

    private final TbVdsCtlrRepository repo;
    private final TbVdsCtlrSttsHsRepository sttsHsRepo;
    private final TbVdsDtctClctPnstRepository rawPnstRepo;

    // 데이터 1건 조회, 없으면 exception
    private TbVdsCtlr requireOne(Long id) throws NoSuchElementException {
        Optional<TbVdsCtlr> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVdsCtlrDto> findAll() {
        List<TbVdsCtlrDto> result = new ArrayList<>();
        List<TbVdsCtlr> data = this.repo.findAll();
        for (TbVdsCtlr entity : data) {
            if (entity.getDelYn() != null && entity.getDelYn().equals("N")) {
                result.add(entity.toDto());
            }
        }
        return result;
    }

    /**
     * 삭제되지 않은 제어기 목록 조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbVdsCtlrDto> findAllList() {
        List<TbVdsCtlrDto> result = new ArrayList<>();
        List<TbVdsCtlr> data = this.repo.findAllList();
        data.forEach(obj -> {
            result.add(obj.toDto());
        });
        return result;
    }

    /**
     * 삭제되지 않은 제어기 상태 목록 조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbVdsCtlrSttsDto> findAllStts() {
        List<TbVdsCtlrSttsDto> result = new ArrayList<>();
        Map<String, TbVdsCtlrSttsDto> tmp = new HashMap<>();
        List<TbVdsCtlr> data = this.repo.findAllList();
        List<SttsHsErrCntInf> colList = this.rawPnstRepo.findAllCommError();
        data.forEach(obj -> {
            TbVdsCtlrSttsDto dto = obj.toSttsDto();
            result.add(dto);
            tmp.put(String.valueOf(dto.getVdsCtlrNmbr()), dto);
        });
        colList.forEach(obj -> {
            TbVdsCtlrSttsDto dto = tmp.get(obj.getNmbr());
            if (dto != null) {
                dto.setCollectInfo(obj.getErrCnt().intValue());
            }
        });
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbVdsCtlrDto findById(Long id) {
        TbVdsCtlr entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbVdsCtlrDto updateById(Long id, TbVdsCtlrDto.TbVdsCtlrUpdReq req) {
        TbVdsCtlr entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbVdsCtlrDto> mergeInfoList(List<TbVdsCtlrDto.TbVdsCtlrUpdReq> reqList) {
        List<TbVdsCtlrDto> result = new ArrayList<>();
        for (TbVdsCtlrDto.TbVdsCtlrUpdReq req : reqList) {
            TbVdsCtlr obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbVdsCtlrDto mergeInfo(TbVdsCtlrDto.TbVdsCtlrUpdReq req) {
        TbVdsCtlr obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbVdsCtlrDto deleteById(Long id) {
        TbVdsCtlr entity = requireOne(id);
        entity.setDelete();
        //this.repo.deleteById(id);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbVdsCtlrDto> deleteByIds(List<Long> ids) {
        List<TbVdsCtlrDto> result = new ArrayList<>();
        for (Long id : ids) {
            Optional<TbVdsCtlr> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    /**
     * 통신이상 시설물 정보 조회
     * @return List<SttsCommErrDto>
     */
    @Transactional(readOnly = true)
    public List<SttsCommErrDto> findAllListCommError() {

        Map<String, SttsCommErrDto> result = new HashMap<>();
        List<TbVdsCtlr> data = this.repo.findAllList();
        List<SttsHsErrCntInf> errList = this.sttsHsRepo.findAllCommErrorCount(ItsUtils.getFromToday());
        List<SttsHsErrCntInf> colList = this.rawPnstRepo.findAllCommError();

        // 통신 상태가 오류 인 제어기 정보만 조회한다.
        data.forEach(obj -> {
            TbVdsCtlrSttsDto dto = obj.toSttsDto();
            if (!CodeManager.CMNC_STTS_NORMAL.equals(dto.getCmncSttsCd())) {
                SttsCommErrDto commErrorDto = new SttsCommErrDto();
                commErrorDto.setCtlrNmbr(String.valueOf(dto.getVdsCtlrNmbr()));
                commErrorDto.setCtlrId(dto.getVdsCtlrId());
                commErrorDto.setCtlrNm(dto.getVdsNm());
                commErrorDto.setUpdtDt(dto.getUpdtDt());
                commErrorDto.setCommCd(dto.getCmncSttsCd());
                commErrorDto.setCommDesc(CodeManager.getCodeDescShort(CodeManager.CMNC_STTS_CD, commErrorDto.getCommCd()));
                commErrorDto.setCommErrCnt(0);
                commErrorDto.setColCnt(0);
                commErrorDto.setColDesc("이상");
                result.put(commErrorDto.getCtlrNmbr(), commErrorDto);
            }
        });

        // 오늘 00:00:00 이후 발생한 오류 건수를 업데이트
        errList.forEach(obj -> {
            SttsCommErrDto dto = result.get(obj.getNmbr());
            if (dto != null) {
                dto.setCommErrCnt(obj.getErrCnt().intValue());
            }
        });

        // 수집이상 조회
        // TODO: 통신오류인 경우 수집상태 처리는 의미가 없는데???
        colList.forEach(obj -> {
            SttsCommErrDto dto = result.get(obj.getNmbr());
            if (dto != null) {
                dto.setColCnt(obj.getErrCnt().intValue());
                if (CodeManager.CMNC_STTS_NORMAL.equals(dto.getCommCd()) && dto.getColCnt() > 0) {
                    // 통신상태가 정상이고 수집건수가 0 개 이상일 경우 수집 정상
                    dto.setColDesc("정상");
                }
            }
        });

        return new ArrayList<>(result.values());
    }

    /**
     * 상태 목록
     * @param
     */
    @Transactional(readOnly = true)
    public FcltSttsListDto findAllSttsListTotal(boolean total) {

        String fcltType = "VDS";
        FcltSttsListDto result = new FcltSttsListDto();

        AtomicInteger normal = new AtomicInteger(0);
        AtomicInteger error = new AtomicInteger(0);
        AtomicInteger colErr = new AtomicInteger(0);
        AtomicInteger doorOpen = new AtomicInteger(0);
        AtomicInteger fanRun = new AtomicInteger(0);
        AtomicInteger hetrRun = new AtomicInteger(0);
        AtomicInteger pwerErr = new AtomicInteger(0);
        AtomicInteger tempErr = new AtomicInteger(0);

        List<SttsHsErrCntInf> colList = this.rawPnstRepo.findAllCommError();
        List<FcltSttsDto> sttsDtoList = new ArrayList<>();
        List<TbVdsCtlr> ctlrList = this.repo.findAllList();

        // 수집이상 조회
        Map<String, SttsCommErrDto> errDtoMap = new HashMap<>();
        colList.forEach(obj -> {
            SttsCommErrDto commErrorDto = new SttsCommErrDto();
            commErrorDto.setCtlrNmbr(obj.getNmbr());
            commErrorDto.setColCnt(obj.getErrCnt().intValue());
            errDtoMap.put(commErrorDto.getCtlrNmbr(), commErrorDto);
        });

        // 상태 설정
        ctlrList.forEach(obj -> {
            TbVdsCtlrSttsDto dto = obj.toSttsDto();
            if (total) {
                FcltSttsDto stts = FcltSttsDto.builder()
                        .fcltType(fcltType)
                        .fcltNmbr(String.valueOf(obj.getVdsCtlrNmbr()))
                        .fcltId(obj.getVdsCtlrId())
                        .fcltNm(obj.getVdsNm())
                        .fcltKind(obj.getVdsTypeCd())
                        .xCrdn(obj.getXCrdn())
                        .yCrdn(obj.getYCrdn())
                        .sttsCd(dto.getCmncSttsCd())
                        .sttsDesc(dto.getCmncSttsDesc())
                        .build();

                sttsDtoList.add(stts);
            }

            if (CodeManager.CMNC_STTS_NORMAL.equals(dto.getCmncSttsCd())) {
                // 통신상태가 정상인 경우
                normal.getAndIncrement();
                SttsCommErrDto commErrorDto = errDtoMap.get(String.valueOf(dto.getVdsCtlrNmbr()));
                if (commErrorDto == null) {
                    // 수집건수 조회 맵에 데이터가 존재하지 않으면 수집한 데이터가 없는 것으로 수집이상임.
                    colErr.getAndIncrement();
                }
                else {
                    if (commErrorDto.getColCnt() == 0) {
                        // 통신상태가 정상인 경우인데 수집건수가 0건 이면 수집오류로 처리
                        colErr.getAndIncrement();
                    }
                }
                if (("CDS1").equals(dto.getCboxDoorSttsCd())) {
                    doorOpen.getAndIncrement();
                }
                if (("PAS0").equals(dto.getFanSttsCd())) {
                    fanRun.getAndIncrement();
                }
                if (("HTS0").equals(dto.getHetrSttsCd())) {
                    hetrRun.getAndIncrement();
                }
                if (("PWS1").equals(dto.getPrntPwerSttsCd())) {
                    pwerErr.getAndIncrement();
                }
                if (dto.getCboxTmpr() > 30 || dto.getCboxTmpr() < -5) {
                    tempErr.getAndIncrement();
                }
            }
            else {
                 error.getAndIncrement();
            }
        });

        FcltSttsSummaryDto summaryDto = FcltSttsSummaryDto.builder()
                .fcltType(fcltType)
                .fcltNm(fcltType)
                .totalCnt(ctlrList.size())
                .normalCnt(normal.get())
                .errorCnt(error.get())
                .colErrCnt(colErr.get())
                .build();

        summaryDto.init();
        summaryDto.setDoorOpen(doorOpen.get());
        summaryDto.setFanRun(fanRun.get());
        summaryDto.setHetrRun(hetrRun.get());
        summaryDto.setPwerErr(pwerErr.get());
        summaryDto.setTempErr(tempErr.get());
        if (total) {
            summaryDto.setFcltObjs(sttsDtoList);
        }
        result.getFcltList().add(summaryDto);

        return result;
    }

    /**
     * 신규 제어기 번호 조회
     * @return
     */
    @Transactional(readOnly = true)
    public NewIdLongDto getNewNmbr() {
        Long newId = this.repo.getNewNmbr();
        return NewIdLongDto.builder().newId(newId).build();
    }

}
